<template>
  <form
    id="editGroupForm"
    novalidate="novalidate"
    :v-model="form"
  >
    <div class="form-group required">
      <label
        for="name"
      >Nom&nbsp;:</label>
      <input
        id="name"
        v-model="form.name"
        name="name"
        type="text"
        minlength="1"
        class="form-control"
        required="required"
      >
    </div>
    <div class="form-group required">
      <label>Entreprise :</label>
      <div
        v-for="(subgroup, index) in form.sirets"
        :key="`subgroup-${index}`"
        class="row"
      >
        <div class="form-group col-md-5">
          <select
            v-model="form.sirets[index].siren"
            :name="`siren-${index}`"
            class="form-control"
            required="required"
            @change="changeSiret(index, subgroup)"
          >
            <option selected="true">
              Toutes les entreprises
            </option>
            <option
              v-for="siren in sirens"
              :key="siren.number"
            >
              {{ siren.number }}
            </option>
          </select>
        </div>
        <div class="form-group col-md-5">
          <select
            v-model="form.sirets[index].nic"
            :name="`nic-${index}`"
            class="form-control"
          >
            <option selected="selected">
              Tous les établissements
            </option>
            <option
              v-for="siret in form.sirets[index].nics"
              :key="siret.nic"
            >
              {{ siret.nic }}
            </option>
          </select>
        </div>
        <div
          class="col-md-2"
        >
          <click-button
            v-if="form.sirets.length===(index+1)"
            :disabled="isLoading"
            @click="addNewLine"
          >
            <template slot="content">
              <add-icon />
            </template>
          </click-button>
          <click-button
            v-if="form.sirets.length!==1"
            :disabled="isLoading"
            @click="removeLine(index)"
          >
            <template slot="content">
              <remove-icon />
            </template>
          </click-button>
        </div>
      </div>
    </div>
    <div
      class="form-group btn-list"
    >
      <click-button
        :disabled="isLoading || form.name.length === 0"
        @click="performUpdateGroup()"
      >
        <template slot="content">
          Modifier le groupement
        </template>
      </click-button>
    </div>
  </form>
</template>
<script>
import {mapActions, mapGetters} from 'vuex'
import VanillaToasts from 'vanillatoasts'
import AddIcon from '../../../components/Icon/AddIcon.vue'
import RemoveIcon from '../../../components/Icon/RemoveIcon.vue'
import ClickButton from "../../Button/ClickButton";
export default {
  name: 'EditGroupForm',
  components: {
    ClickButton,
    AddIcon,
    RemoveIcon
  },
  data() {
    return {
      validator: null,
      form : {
        id: this.$route.params.groupIdentifier,
        name: '',
        sirets: []
      },
    }
  },
  computed: {
    ...mapGetters([
      'isLoading',
      'sirens',
      'sirets',
      'group'
    ])
  },
  created () {
    this.fetchSirensIntegrated().then(() => {
      this.fetchSirets().then(() => {
        this.group.sirets.forEach(siret => {
          this.addLine(siret.nic, siret.siren)
          this.form.name = this.group.name
        })
      })
    })
  },
  mounted() {
    this.validator = $('#editGroupForm').submit(function (e) {
      e.preventDefault();
    }).validate({
      rules: {
        name: {
          required: true
        }
      },
      errorElement: 'em',
      errorPlacement: function (error, element) {
        // Add the `help-block` class to the error element
        error.addClass('help-block');

        if (element.prop("type") === 'checkbox') {
          error.insertAfter(element.parent('label'));
        } else {
          error.insertAfter(element);
        }
      },
      highlight: function (element) {
        $(element).parents(".form-group").addClass("has-error").removeClass("has-success");
      },
      unhighlight: function (element) {
        $(element).parents(".form-group").addClass("has-success").removeClass("has-error");
      }
    });
  },
  methods: {
    ...mapActions([
      'fetchSirensIntegrated',
      'fetchSirets',
      'updateGroup',
      'loadingStarts',
      'loadingEnds'
    ]),
    addLine(nic,siren) {
      this.form.sirets.push({
        siren: siren,
        nic: nic,
        nics: this.nicsFromSiren(siren)
      })
    },
    addNewLine() {
      this.form.sirets.push({
        siren: 'Toutes les entreprises',
        nic: 'Tous les établissements',
        nics: []
      })
    },
    removeLine(index) {
      this.form.sirets.splice(index,1)
    },
    nicsFromSiren(sirenNumber) {
      if(this.sirets!=null) {
        return this.sirets.filter((siret) => {
          return parseInt(siret.siren) === parseInt(sirenNumber)
        })
      }else {
        return []
      }
    },
    changeSiret(index, subgroup) {
      this.form.sirets[index].siret = 'Tous les établissements'
      this.form.sirets[index].nics = this.nicsFromSiren(subgroup.siren)
    },
    performUpdateGroup() {
      if ($("#editGroupForm").valid()) {
        this.loadingStarts()
        this.updateGroup(this.form).then(()=>{
          this.reset()
          VanillaToasts.create({
            title: 'Modification groupement',
            text: 'Opération effectuée avec succès',
            type: 'success',
            timeout: 5000, // hide after 5000ms, // optional paremter
          });
          this.loadingEnds()
          this.$router.push({ path: '/groupements'})
        })
      }
    },
    reset() {
      this.form = {
        id: '',
        name: '',
        sirets: [
        ]
      }
      this.addNewLine()
    },
  }
}
</script>

<style scoped>

</style>